<template lang="html">
<div class="modal is-active">
  <div class="modal-background"></div>
  <div class="modal-content">
    <div class="box has-text-centered process-box" v-if="!isProcessed">
      <p class="subtitle">Computing Histogram...</p>
    </div>

    <div class="box" v-else>
      <div class="card">
        <header class="card-header">
          <p class="card-header-title">Citra Leukosit</p>
        </header>
        <div class="card-image">
          <figure class="image is-4by3">
            <img :src="'data:image/jpg;base64, '+image.file" :alt="image.name">
          </figure>
        </div>
      </div>
      <div class="card">
        <header class="card-header">
          <p class="card-header-title">Histogram Citra</p>
        </header>
        <div class="card-image">
          <figure class="image is-max-width-800px">
            <histogram :datasets="getDataset(['image'])" />
          </figure>
        </div>
      </div>
      <div class="card">
        <header class="card-header">
          <p class="card-header-title">Histogram Region Of Interest</p>
        </header>
        <div class="card-image">
          <figure class="image is-max-width-800px">
            <histogram :datasets="getDataset(['cells'])" />
          </figure>
        </div>
      </div>
      <div class="card">
        <header class="card-header">
          <p class="card-header-title">Histogram Sel</p>
        </header>
        <div class="card-image">
          <figure class="image is-max-width-800px">
            <histogram :datasets="getDataset(['cell'])" />
          </figure>
        </div>
      </div>
    </div>
  </div>
  <button class="modal-close is-large" aria-label="close" @click.stop="$emit('close-modal')"></button>
</div>
</template>

<script>
import histogram from '@/components/base/Histogram.js'
export default {
  components: {
    histogram
  },
  props: {
    hists: Array,
    isProcessed: Boolean,
    image: Object
  },
  data() {
    return {
      // isProcessed: false,
      // dummysets: [
      //   {
      //     label: 1,
      //     borderColor: '#FC2525',
      //     data: [0, 0, 0, .2, .3, .5, .6, .7, .8, .75, .55, .4, .2, 1, 0, 0]
      //   }
      // ]
    }
  },
  methods: {
    getDataset(groups) {
      var data = []
      function makeDataset(data) {
        const datasets = []
        const colors = [ '#2550CC', '#50CC25', '#CC5025']
        let labels = []
        var labelname = ""
        for (var i = 0, k = 1; i < data.length; i++) {
          if (data[i].groups[1] === 'cell') {
            labelname = data[i].groups[1]+"-"+k
            k = i % 3 === 2 ? k+1 : k
          } else {
            labelname = data[i].groups[1]
          }

          datasets.push({
            label: data[i].groups[0][0]+"-"+labelname,
            backgroundColor: colors[i%3],
            data: data[i].hist
          })
        }

        if (data[0].groups.indexOf('image') > -1) {
          labels = Array(256).fill(0).map((v, i) => String(0 + i))
        }
        else {
          labels = ['0-15', '16-31', '32-47', '48-63', '64-79', '80-95', '96-111',
                  '112-127', '128-143', '144-159', '160-175', '176-191', '192-207',
                  '208-223', '224-239', '240-255']
        }
        return {datasets: datasets, labels: labels}
      }
      if (groups.indexOf('image') > -1) {
        data = this.hists.filter(h => h.groups.indexOf('image') > -1)
      } else if (groups.indexOf('cells') > -1) {
        data = this.hists.filter(h => h.groups.indexOf('cells') > -1)
      } else if (groups.indexOf('cell') > -1) {
        data = this.hists.filter(h => h.groups.indexOf('cell') > -1)
      }
      return makeDataset(data)
    }
  }
}
</script>

<style lang="scss">
  .process-box {
    padding-top: 100px;
    padding-bottom: 100px;
  }

  .is-max-width-800px {
    max-width: 1000px;
  }
</style>
